/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package pl.ssr.multikey.sort;

import java.awt.Color;
import java.awt.Component;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.util.List;
import java.util.ArrayList;
import javax.swing.Icon;
import javax.swing.JLabel;
import javax.swing.JTable;
import javax.swing.RowSorter;
import javax.swing.SortOrder;
import static javax.swing.SortOrder.ASCENDING;
import static javax.swing.SortOrder.DESCENDING;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.TableModel;
import javax.swing.table.TableRowSorter;

/**
 * @author ssr
 */
public class MainFrame extends javax.swing.JFrame {

    /**
     * Creates new form MainFrame
     */
    public MainFrame() {
        initComponents();
        initMultiColumnSorter();
        jTable1.getTableHeader().addMouseListener(new MouseAdapter() {
            public void mouseClicked(MouseEvent e) {
                if (SwingUtilities.isRightMouseButton(e)) {
                    int column = jTable1.columnAtPoint(e.getPoint());
                    if (column >= 0) {
                        List<RowSorter.SortKey> keys = new ArrayList<>(jTable1.getRowSorter().getSortKeys());
                        if (keys.removeIf(k -> k.getColumn() == column)) {
                            jTable1.getRowSorter().setSortKeys(keys);
                        }
                    }
                }
            }
        });
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        jTable1 = new javax.swing.JTable();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jTable1.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {
                {"1", "a", "c", "6"},
                {"1", "b", "c", "7"},
                {"2", "a", "c", "6"},
                {"2", "b", "d", "7"}
            },
            new String [] {
                "Title 1", "Title 2", "Title 3", "Title 4"
            }
        ));
        jScrollPane1.setViewportView(jTable1);

        getContentPane().add(jScrollPane1, java.awt.BorderLayout.CENTER);

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels()) {
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
//                     UIManager.getLookAndFeelDefaults().put("Table.ascendingSortIcon", new BevelArrowIcon(BevelArrowIcon.UP, false, false));
//                    UIManager.getLookAndFeelDefaults().put("Table.descendingSortIcon", new BevelArrowIcon(BevelArrowIcon.DOWN, false, false));

                    break;
                }
            }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(MainFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(MainFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(MainFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(MainFrame.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new MainFrame().setVisible(true);
            }
        });
    }

    //@see http://java-swing-tips.blogspot.com/2008/09/jdk6-cycle-through-ascending-descending.html
    private void initMultiColumnSorter() {
        jTable1.getTableHeader().setDefaultRenderer(new TestTableCellRenderer(jTable1));
        TableRowSorter<TableModel> sorter = new TableRowSorter<TableModel>(jTable1.getModel()) {

            @Override
            public void toggleSortOrder(int column) {
                int keyIndex;
                if (column >= 0 && column < getModelWrapper().getColumnCount() && isSortable(column)) {
                    List<RowSorter.SortKey> keys = new ArrayList<>(getSortKeys());
                    boolean found = false;
                    for (keyIndex = 0; keyIndex < keys.size(); keyIndex++) {
                        RowSorter.SortKey sortKey = keys.get(keyIndex);
                        if (sortKey.getColumn() == column) {
                            found = true;
                            break;
                        }
                    }

                    if (isSortable(column)) {
                        if (!found) {
                            // Key doesn't exist
                            RowSorter.SortKey sortKey = new RowSorter.SortKey(column, SortOrder.ASCENDING);
                            keys.add(sortKey);
                            System.out.println("ADDED: ");
                            keys.stream().forEach(k -> System.out.println(k.getColumn() + ":" + k.getSortOrder()));
                        } else {
                            RowSorter.SortKey sortKey = keys.get(keyIndex);
                            if (sortKey.getSortOrder() == SortOrder.DESCENDING) {
                                keys.remove(keyIndex);
                                System.out.println("REMOVED: ");
                                keys.stream().forEach(k -> System.out.println(k.getColumn() + ":" + k.getSortOrder()));
                            } else {
                                keys.set(keyIndex, new RowSorter.SortKey(column, sortKey.getSortOrder() == SortOrder.ASCENDING ? SortOrder.DESCENDING : SortOrder.ASCENDING));
                                System.out.println("MODIFIED: ");
                                keys.stream().forEach(k -> System.out.println(k.getColumn() + ":" + k.getSortOrder()));
                            }
                        }
                        if (keys.size() > getMaxSortKeys()) {
                            keys = keys.subList(0, getMaxSortKeys());
                        }
                        setSortKeys(keys);
                    }
                }
            }
        };
        sorter.setMaxSortKeys(4);
        jTable1.setRowSorter(sorter);
    }

    protected class TestTableCellRenderer extends DefaultTableCellRenderer {

        DefaultTableCellRenderer delegate;

        TestTableCellRenderer() {
            this.delegate = (DefaultTableCellRenderer) new JTable().getTableHeader().getDefaultRenderer();
        }

        TestTableCellRenderer(JTable table) {
            this.delegate = (DefaultTableCellRenderer) table.getTableHeader().getDefaultRenderer();
        }

        @Override
        public Component getTableCellRendererComponent(JTable table, Object value, boolean isSelected, boolean hasFocus, int row, int column) {
            JLabel l = (JLabel) delegate.getTableCellRendererComponent(table, value, isSelected, hasFocus, row, column);
            l.setIcon(getIcon(table, column));
            return l;
        }

        public Icon getIcon(JTable table, int column) {
            List<? extends RowSorter.SortKey> keys = table.getRowSorter().getSortKeys();
            for (int i = 0; i < table.getRowSorter().getSortKeys().size(); i++) {
                RowSorter.SortKey sortKey = keys.get(i);
                if (sortKey.getColumn() == column) {
                    switch (sortKey.getSortOrder()) {
                        case ASCENDING:
                            return new NumberedIcon(UIManager.getIcon("Table.ascendingSortIcon"), i + 1);
                        case DESCENDING:
                            return new NumberedIcon(UIManager.getIcon("Table.descendingSortIcon"), i + 1);
                    }
                }
            }
            return null;
        }
    }

    static class NumberedIcon implements Icon {

        private final Icon icon;
        private final String numberString;
        private final int width;
        private final int height;

        private static final float FONT_SIZE = 10f;

        NumberedIcon(Icon icon, int number) {
            this.icon = icon;
            this.numberString = "[" + number + "]";
            this.height = icon.getIconHeight();
            this.width = icon.getIconWidth() + (int) FONT_SIZE;
        }

        @Override
        public void paintIcon(Component c, Graphics g, int x, int y) {
            Graphics g2 = g.create();
            icon.paintIcon(c, g2, x, y);
            g2.setColor(Color.BLACK);
            g2.setFont(g.getFont().deriveFont(Font.BOLD, FONT_SIZE));
            FontMetrics fm = g2.getFontMetrics();
            g2.drawString(numberString, x + icon.getIconWidth() + 1, y + (height + fm.getHeight() / 2) / 2);
            g2.dispose();

        }

        @Override
        public int getIconWidth() {
            return width;
        }

        @Override
        public int getIconHeight() {
            return height;
        }

    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jTable1;
    // End of variables declaration//GEN-END:variables
}
